/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 25/10/2017
 --------------------------------------------------------
*/
package com.portofolio.controller;

import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.validation.Valid;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Lazy;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import com.portofolio.base.LocaleController;
import com.portofolio.dto.PangkatDto;
import com.portofolio.service.PangkatService;
import com.portofolio.util.RestUtil;

import io.swagger.annotations.ApiOperation;


@SuppressWarnings("rawtypes")
@Lazy
@RestController
@RequestMapping("/pangkat")
public class PangkatController extends LocaleController {
    @Lazy
	@Autowired
    private PangkatService pangkatService;
    
    
    @ApiOperation("Api Untuk Menyimpan Pangkat")
    @PostMapping("/save")
    public ResponseEntity<Map<String, Object>> save(@Valid @RequestBody PangkatDto entity,HttpServletRequest request) {
        Map<String, Object> result = pangkatService.save(entity);
        return RestUtil.getJsonResponse(result);
    }
    
    @ApiOperation("Api Untuk Update Pangkat")
    @PutMapping("/update")
    public ResponseEntity<Map<String, Object>> update(
    		@RequestParam(value = "kdPangkat", required = true) Integer kdPangkat,
    		@RequestParam(value = "version", required = true) Integer version,
    		@Valid @RequestBody PangkatDto entity, HttpServletRequest request) {
        Map<String, Object> result = pangkatService.update(entity,kdPangkat,version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menghapus Pangkat Berdasarkan KdPangkat")
    @DeleteMapping("/delete")
    public ResponseEntity<Map<String, Object>> deleteById(
    		@RequestParam(value = "kdPangkat", required = true) Integer kdPangkat,
    		@RequestParam(value = "version", required = true) Integer version
    		) {
        Map<String, Object> result = pangkatService.deleteById(kdPangkat, version);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Semua Pangkat")
    @GetMapping("/grid")
    public ResponseEntity<Map<String, Object>> grid(
    		@RequestParam(value = "page", defaultValue = "1") Integer page, 
    		@RequestParam(value = "rows", defaultValue = "10") Integer rows,			
    		@RequestParam(value = "dir", defaultValue = "namaPangkat") String dir,			
    		@RequestParam(value = "sort", defaultValue = "desc") String sort,			
    		@RequestParam(value = "namaPangkat", required = false) String namaPangkat,
    		@RequestParam(value = "statusEnabled", required = true) boolean statusEnabled) {
        Map<String, Object> result = pangkatService.grid(page, rows, sort, dir, namaPangkat,statusEnabled);
        return RestUtil.getJsonResponse(result);
    }
    
    
    @ApiOperation("Api Untuk Menampilkan Pangkat Berdasarkan kdPangkat")
    @GetMapping("/findByKdPangkat")
    public ResponseEntity<Map<String, Object>> findByKdPangkat(
    		@RequestParam(value = "kdPangkat", required = true) Integer kdPangkat, 
    		HttpServletRequest request) {
        Map<String, Object> result = pangkatService.findByKdPangkat(kdPangkat);
        return RestUtil.getJsonResponse(result);
    }


}
